unit Stange;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, dglOpenGL, Mesh;

type

  { TStange }

  TStange = class(TObject)
  private
    Mesh: TMesh;
    ListIndex: GLuint;
  public
    constructor Create(d, l: single; col: TGLVectorf3);
    destructor Destroy; override;
    procedure Draw;
  end;

implementation

{ TStange }

constructor TStange.Create(d, l: single; col: TGLVectorf3);
var
  d2: single;
  c1, c2: TGLVectorf3;
  i: integer;
begin
  c1 := col;
  c2 := col;
  for i := 0 to 2 do begin
    c2[i] := c2[i] / 1.3;
  end;
  Mesh := TMesh.Create;
  ListIndex := glGenLists(1);

  glNewList(ListIndex, GL_COMPILE);
  d2 := d / 2;

  glBegin(GL_QUADS);
  glColor3fv(@c1);
  glVertex3f(d2, -d2, 0);
  glVertex3f(l - d2, -d2, 0);
  glColor3fv(@c2);
  glVertex3f(l - d2, d2, 0);
  glVertex3f(d2, d2, 0);
  glEnd();

  glTranslatef(0, 0, -0.01);
  Mesh.col1 := c1;
  Mesh.col2 := c2;
  Mesh.Disk(d / 2, d);

  glTranslatef(l, 0.0, 0.0);
  Mesh.Disk(d / 2, d);

  glEndList;
end;

destructor TStange.Destroy;
begin
  Mesh.Free;
  glDeleteLists(ListIndex, 1);
  inherited Destroy;
end;

procedure TStange.Draw;
begin
  glPushMatrix;
  glCallList(ListIndex);
  glPopMatrix;
end;

end.
