unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, OpenGLContext, LCLType, StdCtrls, Types, Math,

  {$ifdef arm}
  dglOpenGLSE,
  {$else}
  dglOpenGL,
  {$endif}

  Mesh, MyMath, Rad, Stange;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    OpenGLControl1: TOpenGLControl;
    Panel1: TPanel;
    Timer1: TTimer;
    ToggleBoxTimer: TToggleBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OpenGLControl1Paint(Sender: TObject);
    procedure OpenGLControl1Resize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ToggleBoxTimerChange(Sender: TObject);

  public
    Mesh: TMesh;
    Rad: TRad;
    PleuelSchwinge1, PleuelSchwinge2, PleuelSchwinge3, PleuelSchwinge4,
    Schubstange, Pleuel, Zylinder: TStange;

    Abstand: TPointf;
    Pleuel1L, Pleuel2L, Pleuel3L, Pleuel4L: single;
    speed, winkel: single;
    procedure BackGround;
  end;

var
  Form1: TForm1;

implementation


const
  radR = 0.5;


{ TForm1 }

procedure TForm1.BackGround;
begin
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity();

  glBegin(GL_QUADS);
  glColor3f(0.4, 0.2, 0.3);
  glVertex3f(-1.0, -1.0, 0.999);
  glColor3f(0.45, 0.25, 0.3);
  glVertex3f(+1.0, -1.0, 0.999);
  glColor3f(0.4, 0.25, 0.53);
  glVertex3f(+1.0, +1.0, 0.999);
  glColor3f(0.45, 0.2, 0.35);
  glVertex3f(-1.0, +1.0, 0.999);
  glEnd();

  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  winkel += speed;
  if winkel > 360 then begin
    winkel -= 360;
  end;
  OpenGLControl1.Repaint;
  Caption := TimeToStr(Now);
end;

procedure TForm1.ToggleBoxTimerChange(Sender: TObject);
begin
  Timer1.Enabled := ToggleBoxTimer.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitOpenGL;
  ReadExtensions;
  ReadImplementationProperties;
  OpenGLControl1.MakeCurrent;

  Abstand.x := 1.2;
  Abstand.y := 0.3;
  Pleuel1L := Abstand.x * 0.95;
  Pleuel2L := Abstand.x / 2.1;
  Pleuel3L := Abstand.x / 1.2;
  Pleuel4L := Abstand.x / 2.3;


  Mesh := TMesh.Create;
  Rad := TRad.Create(radR);

  Schubstange := TStange.Create(radR / 8, 1.2, vec3(1.0, 0.2, 0.2));
  Pleuel := TStange.Create(radR / 8, Abstand.x, vec3(1.0, 0.2, 0.2));
  Zylinder := TStange.Create(radR / 8, Abstand.x / 2, vec3(1.0, 0.2, 0.2));

  PleuelSchwinge1 := TStange.Create(radR / 24, Pleuel1L, vec3(0.2, 1.0, 0.2));
  PleuelSchwinge2 := TStange.Create(radR / 24, Pleuel2L, vec3(0.2, 0.2, 1.0));
  PleuelSchwinge3 := TStange.Create(radR / 24, Pleuel3L, vec3(1.0, 0.2, 0.2));
  PleuelSchwinge4 := TStange.Create(radR / 24, Pleuel4L, vec3(1.0, 0.2, 0.2));
  speed := 3.01;

  Trigo.Grad := True;
  Timer1.Enabled := True;
end;

procedure TForm1.OpenGLControl1Paint(Sender: TObject);
var
  Exzenter_xy: TPointf;
  p: single;
  Schwinge1, Schwinge2: TSchwinge;

begin
  glClearColor(0.4, 0.2, 0.3, 1.0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
  BackGround;

  //  glScalef(1.5, 1.5, 1.5);
  glTranslatef(-4.2, 0.0, 0.0);

  glColor3f(1, 1, 1);
  Mesh.Arc(radR * 1.2, radR * 1.4, 90, 180.0); // deutet eine Schwinge1 an
  glColor3f(1, 0.1, 1);
  Mesh.Arc(radR * 1.4, radR * 1.6, -30, 30); // deutet eine Schwinge1 an

  Rad.Draw(winkel);
  glTranslatef(Abstand.x, 0.0, 0.0);
  Rad.Draw(winkel);
  glTranslatef(Abstand.x, 0.0, 0.0);
  Rad.Draw(winkel);

  glPushMatrix;
  glTranslatef(0, 0, -0.03);

  // --- Schubstange

  Exzenter_xy := Trigo.Alpha_c_To_xy(winkel, radR * 0.65);

  glTranslatef(Exzenter_xy.x, Exzenter_xy.y, 0);

  glPushMatrix;
  glTranslatef(-Abstand.x, 0.0, 0.0);
  Schubstange.Draw;
  glTranslatef(-Abstand.x, 0.0, 0.0);
  Schubstange.Draw;
  glPopMatrix;

  // --- Pleuel

  //  glRotatef(arcsin(-Exzenter_xy.y / Abstand.x) / Pi * 180.0, 0.0, 0.0, 1.0);
  glRotatef(-Trigo.a_c_To_Alpha(Exzenter_xy.y, Abstand.x), 0.0, 0.0, 1.0);
  //  glRotatef(arccos(-zx / Abstand) / Pi * 180.0, 0.0, 0.0, 1.0); // senkrecht
  Pleuel.Draw;
  glPopMatrix;

  // --- Zylinder

  glPushMatrix;
  p := sqrt(sqr(Abstand.x) - sqr(Exzenter_xy.y)) + Exzenter_xy.x;
  glTranslatef(p, 0.0, 0.0);
  Zylinder.Draw;
  glPopMatrix;

  glPushMatrix;
  if winkel < 180.0 then begin
    glRotatef(winkel / 10, 0.0, 0.0, 1.0);
  end else begin
    glRotatef(180.0 / 10 - (winkel / 10 - 180.0 / 10), 0.0, 0.0, 1.0);
  end;
  Mesh.Arc(radR * 1.2, radR * 1.4, 0, 60); // deutet eine Schwinge1 an
  glPopMatrix;


  // --- Schwinge1 ---

  Schwinge1.SetParam(winkel+60, radR * 0.85, Abstand.x, Abstand.y, Pleuel1L, Pleuel2L);

  // Pleuel

  glPushMatrix;

  glTranslatef(Schwinge1.RadExzenter.x, Schwinge1.RadExzenter.y, -0.2);
  glRotatef(Schwinge1.Pleuel_W, 0.0, 0.0, 1.0);
  PleuelSchwinge1.Draw;

  glPopMatrix;

  // Schwinge

  glPushMatrix;

  glTranslatef(Abstand.x, Abstand.y, -0.2);
  glRotatef(Schwinge1.Schwinge_W, 0.0, 0.0, 1.0);
  PleuelSchwinge2.Draw;

  glPopMatrix;


  // --- Schwinge2 ---

  glPushMatrix;
  glTranslatef(Abstand.x, Abstand.y, -0.2);

  //  Schwinge2.SetParam(Schwinge1.Schwinge_W, Pleuel2L / 2, Abstand.x, Abstand.y - 0.8, Pleuel3L, Pleuel4L);
  Schwinge2.SetParam(Schwinge1.Schwinge_W, Pleuel2L / 2, p - Abstand.x / 2, Abstand.y - 0.6, Pleuel3L, Pleuel4L);

  // Pleuel

  glPushMatrix;

  glTranslatef(Schwinge2.RadExzenter.x, Schwinge2.RadExzenter.y, -0.2);
  glRotatef(Schwinge2.Pleuel_W, 0.0, 0.0, 1.0);
  PleuelSchwinge3.Draw;

  glPopMatrix;

  // Schwinge


  glPushMatrix;

  //  glTranslatef(Abstand.x, Abstand.y - 0.8, -0.2);
  glTranslatef(p - Abstand.x / 2, Abstand.y - 0.6, -0.2);
  glRotatef(Schwinge2.Schwinge_W, 0.0, 0.0, 1.0);
  PleuelSchwinge4.Draw;

  glPopMatrix;


  glPopMatrix;


  OpenGLControl1.SwapBuffers;
end;

procedure TForm1.OpenGLControl1Resize(Sender: TObject);
begin
  with OpenGLControl1 do begin
    glViewport(0, 0, Width, Height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glScalef(Height / Width, 1.0, 1.0);
  end;
end;


procedure TForm1.FormDestroy(Sender: TObject);
begin
  Rad.Free;
  Mesh.Free;
  Schubstange.Free;
  Pleuel.Free;
  Zylinder.Free;
  PleuelSchwinge1.Free;
  PleuelSchwinge2.Free;
  PleuelSchwinge3.Free;
  PleuelSchwinge4.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  speed *= 1.1;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  speed /= 1.1;
end;

initialization

  {$I unit1.lrs}

end.
